
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>boost.asio系列——io_service / iVAN</title>

    <meta name="description" content="boost.asio系列——io_service IO模型 io_service对象是asio框架中的调度器,所有异步io事件都是通过它来分发处理的(io对象的构造函数中都需要传入一个io_service对象).     asio::io_service io_service;    asio::ip::tcp::socket socket(io_service); 在asio框架中,同步的io主要流程如下:      应用程序调用IO对象成员函数执行IO操作 IO对象向io_service 提出请求. io_service 调用操作系统的功能">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">boost.asio系列——io_service</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>IO模型</strong></p>
<p>io_service对象是asio框架中的调度器，所有异步io事件都是通过它来分发处理的（io对象的构造函数中都需要传入一个io_service对象）。</p>
<p>    asio::io_service io_service;<br />    asio::ip::tcp::socket socket(io_service);</p>
<p>在asio框架中，同步的io主要流程如下：</p>
<p>    <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zOTQ0ZWQ1NDJjOTNjMjcwZTViOGFjODFjNDBlOTY4YS5qcGc=.jpg"></p>
<ol>
<li>应用程序调用IO对象成员函数执行IO操作</li>
<li>IO对象向io_service 提出请求.</li>
<li>io_service 调用操作系统的功能执行连接操作.</li>
<li>操作系统向io_service 返回执行结果.</li>
<li>io_service将错误的操作结果翻译为boost::system::error_code类型，再传递给IO对象.</li>
<li>如果操作失败,IO对象抛出boost::system::system_error类型的异常.</li>
</ol>
<p>而异步IO的处理流程则有些不同：</p>
<p>    <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19kODY4ODcxNTcwNWM3MTdmNzdiZmQwMTkxMmNmNTNhYy5qcGc=.jpg"></p>
<ol>
<li>应用程序调用IO对象成员函数执行IO操作</li>
<li>IO对象请求io_service的服务</li>
<li>io_service 通知操作系统其需要开始一个异步连接.</li>
<li>操作系统指示连接操作完成, io_service从队列中获取操作结果</li>
<li>应用程序必须调用io_service::run()以便于接收结果</li>
<li>调用io_service::run()后,io_service返回一个操作结果,并将其翻译为error_code,传递到事件回调函数中</li>
</ol>
<p><strong>io_service对象</strong></p>
<p>io_service对象主要有两个方法——post和run：</p>
<ol>
<li>post用于发布io事件，如timer，socket读写等，一般由asio框架相应对象调用，无需我们显式调用。</li>
<li>run用于监听io事件响应，并执行响应回调，对于异步io操作需要在代码中显式调用，对于同步io操作则由io对象隐式调用（并不是run函数，不过也是等待io事件）。</li>
</ol>
<p>可见，io_service提供的是一个生产者消费者模型。在异步io操作中需要我们手动控制消费者，调用run函数，它的基本工作模式如下：</p>
<ol>
<li>等待io事件响应，如果所有io事件响应完成则退出</li>
<li>等待到io事件响应后，执行其对应的回调</li>
<li>继续等待下一个io事件，重复1-2</li>
</ol>
<p>从中可以看出，io_service是一个工作队列的模型。在使用过程中一般有如下几个需要注意的地方：</p>
<p><strong>1. run函数在io事件完成后会退出，导致后续基于该对象的异步io任务无法执行</strong></p>
<p>由于io_service并不会主动常见调度线程，需要我们手动分配，常见的方式是给其分配一个线程，然后执行run函数。但run函数在io事件完成后会退出，线程会终止，后续基于该对象的异步io任务无法得到调度。</p>
<p>解决这个问题的方法是通过一个asio::io_service::work对象来守护io_service。这样，即使所有io任务都执行完成，也不会退出，继续等待新的io任务。</p>
<p>    boost::asio::io_service io;<br />    boost::asio::io_service::work work(io);<br />    io.run();</p>
<p><strong>2. 回调在run函数的线程中同步执行，当回调处理时间较长时阻塞后续io响应</strong></p>
<p>解决这个问题的方法有两种：1. 启动多线程执行run函数（run函数是线程安全的），2. 新启动一个线程（或通过线程池）来执行回调函数。一般来讲，如果回调处理事件不是特别短，应该使用在线程池中处理回调的方式。</p>
<p><strong>3. 回调在run函数的线程中同步执行，io事件较多的时候得不到及时响应</strong></p>
<p>这个其实是性能问题了，在多核cpu上可以通过在多个线程中执行run函数来解决这一问题。这种方式也只能充分利用cpu性能，本身性能问题就不是光靠软件就能解决的。</p>
<p><strong>.net中的异步io调度方式</strong></p>
<p>和io_service这种手动控制的方式比起来，.net则是纯粹的自动档了。IO调度由CLR托管了，无需手动控制。回调也是在线程池中执行，无需担心影响后续IO响应。</p>
<p>正是由于CLR的托管，在.net 的异步IO框架中，就没有类似io_service的调度对象存在，这也符合.net的一贯简洁做法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 07:04:01</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e6%93%8d%e4%bd%9c%e7%b3%bb%e7%bb%9f/" title="操作系统">操作系统</a>, <a href="https://www.iamivan.net/tag/socket/" title="socket">socket</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/boost/" title="boost">boost</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>boost.asio系列——io_service的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXjDVyb.html" rel="bookmark">boost asio中io&lowbar;service类的几种使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				io_service类 你应该已经发现大部分使用Boost.Asio编写的代码都会使用几个io_service的实例.io_service是这个库里面最重要的类:它负责和操作系统打交道,等待所有异步操作的结束,然后为每一个异步操作调用其完成处理程序.如果你选择用同步的方式来创建你的应用,你则不需要考虑我将在这一节向你展示的东西. 你有多种不同的方式来使用io_service.在下面的例子中,我们有3个异步操作,2个socket连接操作和一个计时器等待操作:有一个io_service实例和一个处理			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBg3qAM.html" rel="bookmark">boost&period;asio系列&mdash;&mdash;Timer</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同步Timer   asio中提供的timer名为deadline_timer,它提供了超时计时的功能.首先以一个最简单的同步Timer为例来演示如何使用它.     #include &lt;iostream&gt;    #include &lt;boost/asio.hpp&gt;     int main()    {        boost::asio::io_service io;        boost::asio::deadline_timer timer(io, boost::pos			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDnaglM.html" rel="bookmark">boost&period;asio系列&mdash;&mdash;socket编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asio的主要用途还是用于socket编程,本文就以一个tcp的daytimer服务为例简单的演示一下如何实现同步和异步的tcp socket编程. 客户端 客户端的代码如下:     #include &lt;iostream&gt;    #include &lt;boost/array.hpp&gt;    #include &lt;boost/asio.hpp&gt;     using boost::asio::ip::tcp;     int main(int argc, char* argv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Y5YZz.html" rel="bookmark">boost&period;asio系列&mdash;&mdash;buffer</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				创建buffer   在io操作中,对数据的读写大都是在一个缓冲区上进行的,在asio框架中,可以通过asio::buffer函数创建一个缓冲区来提供数据的读写.buffer函数本身并不申请内存,只是提供了一个对现有内存的封装.     char d1[128];    size_t bytes_transferred = sock.receive(asio::buffer(d1)); 直接用字符串做buffer也是常见的形式:     string str = &quot; hello world &q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLgNevM.html" rel="bookmark">boost asio io&lowbar;service学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				构造函数 构造函数的主要动作就是调用CreateIoCompletionPort创建了一个初始iocp. Dispatch和post的区别 Post一定是PostQueuedCompletionStatus并且在GetQueuedCompletionStatus 之后执行. Dispatch会首先检查当前thread是不是io_service.run/runonce/poll/poll_once线程,如果是,则直接运行. poll和run的区别 两者代码几乎一样,都是首先检查是否有outstan			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQ5jRp.html" rel="bookmark">boost&colon;&colon;asio译文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Christopher Kohlhoff Copyright 2003-2012 Christopher M. Kohlhoff 以Boost1.0的软件授权进行发布(见附带的LICENSE_1_0.txt文件或从http://www.boost.org/LICENSE_1_0.txt) Boost.Asio是用于网络和低层IO编程的跨平台C++库,为开发者提供了C++环境下稳定的异步模型. 综述 基本原理 应用程序与外界交互的方式有很多,可通过文件,网络,串口或控制台.例如在网络通信中,完成独			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YwQKM.html" rel="bookmark">boost&period;asio包装类st&lowbar;asio&lowbar;wrapper开发教程（2014&period;5&period;23更新）（一）-----转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:什么是st_asio_wrapper它是一个c/s网络编程框架,基于对boost.asio的包装(最低在boost-1.49.0上调试过),目的是快速的构建一个c/s系统: 二:st_asio_wrapper的特点效率高.跨平台.完全异步,当然这是从boost.asio继承而来:自动重连,数据透明传输,自动解决分包粘包问题(必须使用默认的打包解包器,这一特性表现得与udp一样):只支持tcp和udp协议: 三:st_asio_wrapper的大体结构st_asio_wrapper.h:编译器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWB1mz.html" rel="bookmark">linux下eclipse使用boost asio进行网络开发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 linux下eclipse使用boost asio进行网络开发 我按照官方文档编译了boost库并安装,然后我的eclipse工程下的/usr/local/include底下已经有了boost 接着我编译官网上的例子: #include #include #include using namespace std; using namespace boost; int main() { boost::asio::io_service io; boost::asio::deadline_t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2RNl3b.html" rel="bookmark">boost&colon;&colon;asio的http client应用笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 踩过的坑 1.1 io_service boost::asio::io_service::run()会一直运行到没有任务为止,如果中途调用stop(),则所有等待中的任务会立刻执行.要在停止的时候抛弃所有的任务,解决方案是用run_one(),即 while (keep_running) io_service_.run_one(); keep_running是个bool值,要stop io_service的时候直接置false即可. 1.2 deadline_timer 在调用async_w			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbadvXz.html" rel="bookmark" class="title">电脑回收站中ai文件删不掉该怎么办&quest;</a>
					<div>
						  电脑回收站中ai文件删不掉该怎么办? 某天发现扔到回收站里的.ai文件删不掉又还原不了,清空回收站无限读条,网上搜到的方法什么unlocker什么360什么改                    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRDl3z.html" rel="bookmark" class="title">跳转-如何设置点击音乐文件弹出我的音乐播放器并自动播放点击的音乐文件</a>
					<div>
						问题描述 如何设置点击音乐文件弹出我的音乐播放器并自动播放点击的音乐文件 2C 现在的功能实现了点击音乐文件能弹出我的音乐播放器界面,但是不能自动播放音乐,请问这个怎么解决啊? 解决方案 能弹出(也就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR8Wez.html" rel="bookmark" class="title">关于Schema的名字空间</a>
					<div>
						名字空间   基本的XML Schema的使用就是这样,下面我们要介绍XML Schema的另外一个核心的部分也是Schema最关键的一个部分,就是关于Schema的名字空间(namespace)的问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNLayz.html" rel="bookmark" class="title">唯有努力方能拨开云雾见晴天</a>
					<div>
						网站无人知晓,每天的pv都是自己登陆产生,ip也是自己的唯一一个,这正是乌云密布的天气,在这种情况下,要调整好心情,努力努力再努力,唯有如此,才能拨开云雾见晴天! 2002到2007年之前的5年里,是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b35D7p.html" rel="bookmark" class="title">设计师感受&colon;技术必须掌握而且保持对它的敏感</a>
					<div>
						有个设计小兵问:&quot;我能不能只做纯设计,不参与实际的项目制作啊?那些东西太枯燥乏味了,不适合我.&quot; 我回:&quot;纯设计是什么?你觉得什么适合你?&quot;,小兵很有信心:&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy9L3b.html" rel="bookmark" class="title">谈表达式树的缓存（6）：五种缓存方式的性能比较</a>
					<div>
						开始还债,因为还有至少两个可写的重要话题依赖在这个系列上,不解决就难以前进. 目前我们已经涉及了五种不同的缓存实现,它们分别是: SimpleKeyCache:构造字符串作为Key,使用字典作为存储. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6YkEz.html" rel="bookmark" class="title">仿酷狗html5手机音乐播放器主要部分代码</a>
					<div>
						  HTML5作品,经测试,效果确定不错,遗憾的是只支持谷歌和苹果等以webkit核心的浏览器,网友体验的时候请使用谷歌等浏览器来运行,不然的话无法看到效果,不说了,看效果吧 复制代码 代码如下: 主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo72d3b.html" rel="bookmark" class="title">优秀网页设计&colon; 分享50个自适应Web设计实例</a>
					<div>
						Responsive Web Design,自适应Web设计,也有翻译成响应式Web设计的,个人认为前者更准确些.可以简单地理解为,网页布局可根据用户的显示屏幕分辨率自动调整 宽度及布局,例如4列12 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6R71b.html" rel="bookmark" class="title">js给页面加style无效果的解决方法</a>
					<div>
						 js给页面加style没有效果的情况,想必大家都有见到吧,下面有个不错的解决方法,大家可以参考下 今天做项目时遇到一个问题,我的a.jsp引入了b.jsp,c.jsp也引入了b.jsp,而b.jsp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmoe8z.html" rel="bookmark" class="title">如何激活Vista隐藏的功能</a>
					<div>
						虽然Windows Vista 5219还只是一个不算太成熟的测试版本,但喜欢尝鲜的朋友已经抢先安装,关于Windows Vista的安装和新特性这里就不再多介绍,笔者今天要介绍的是系统中隐藏的几个功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKR8AM.html" rel="bookmark" class="title">如何处理后期光线不好的时候拍出来的照片</a>
					<div>
						相信许多摄影小伙伴和我一样使用的相机并不是全画幅的相机,再加上懒和其他的各种问题也不使用灯和其他光照用具.面对不同摄影主题的地方不一定都是光线充足的地方.因此拍出来的照片并不完美.或者因为相机的不足只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6L7mb.html" rel="bookmark" class="title">《上古卷轴5：天际》法师学院毁灭大师任务攻略</a>
					<div>
						此任务当时着实令在下不解.法劳达妹子就给了一本书,叫什么&lt;元素之力&gt;,好吧,书我还看不懂-经了解,此任务应这样做:步骤一,拿上课本去迎风遗址.在祭坛上放上课本,用火系法术来一炮. 步骤二, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOar8vM.html" rel="bookmark" class="title">打印机卡纸了怎么办</a>
					<div>
						  步骤一:关闭打印机,再把左侧的盖子打开.如下图所示: 步骤二:打开左侧的盖子以后就可以看到打印机里卡的纸张. 步骤三:不要直接拉卡的纸,这样会拉不出来的,如图所示旁有一个滚轮,可以把纸退后或前进到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3LjOp.html" rel="bookmark" class="title">学生专享：云翼计划&lpar;云主机118元&sol;年&rpar; &ndash;这是大学生成长计划，为了更好的明天，让自己脱颖而出！</a>
					<div>
						又是一年开学季.阿里云推出的云翼计划,目的是让同学们以超低的价格(比原价一折还要低),拥有自己的第一台云服务器.让已经不是学生的我真是羡慕嫉妒恨呀. 如下是教程:STEP1:注册阿里云账号并完成实名认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Ny81M.html" rel="bookmark" class="title">解决jquery实现的radio重新选中的问题&lowbar;jquery</a>
					<div>
						&lt;input type=&quot;radio&quot; name=&quot;test&quot;/&gt; &lt;input type=&quot;radio&quot; name=&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My30elz.html" rel="bookmark" class="title">cannot run-JAVA写成后导出apk文件无法运行</a>
					<div>
						问题描述 JAVA写成后导出apk文件无法运行 初学JAVA,想做一个两个页面间跳转的APP,主页面输入用户名密码(为方便起见,先将其在程序中设定为1234,不等于1234则跳转第二个页面重新输入,等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKG67b.html" rel="bookmark" class="title">判断素数</a>
					<div>
						问题描述 高手帮忙请问给个最快判断一个大数是否为素数的算法谢谢 解决方案 解决方案二:费马小定理?解决方案三:问算法还是API?算法,搜索primesieve,这个图文并茂API的话,使用BigInt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqwO4z.html" rel="bookmark" class="title">HQL 问题 ！！！</a>
					<div>
						问题描述 HQL支持 insert into 表名1 select * from 表名2 吗问题补充:这个是继承了org.springframework.orm.hibernate3.support. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEZJ3M.html" rel="bookmark" class="title">为什么我的电脑安装了windows server 2003并配置好了IIS和asp&period;net组件还是显示不了&period;aspx文件啊</a>
					<div>
						问题描述 这个和IIS和ASP.NET的安装顺序有关吗我在装完系统就自带.netframework1.1 解决方案 解决方案二:看看基类是不是.netframework2.0解决方案三:检查你的程序使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1GlAz.html" rel="bookmark" class="title">c&plus;&plus;书上的一个问题，初学者 请多多指教</a>
					<div>
						问题描述 c++书上的一个问题,初学者 请多多指教 #include using namespace std; class Point{ public: Point() :x(0), y(0){ co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmX13M.html" rel="bookmark" class="title">python里面weave嵌入c语言的问题</a>
					<div>
						问题描述 python里面weave嵌入c语言的问题 http://blog.csdn.net/rumswell/article/details/6563078 我用自己的跑了一下这个贴子的代码发现报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL5r6p.html" rel="bookmark" class="title">ubuntu搭建个人git服务器</a>
					<div>
						ubuntu server 端: apt install git apt install openssh-server 在服务器上部署git仓库: mkdir repos sudo addgroup  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4y7qz.html" rel="bookmark" class="title">mysql中order by 语句的用法 索引优化</a>
					<div>
						MySQL Order By keyword是用来给记录中的数据进行分类的. MySQL Order By Keyword根据关键词分类 ORDER BY keyword是用来给记录中的数据进行分类的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXlNWz.html" rel="bookmark" class="title">想做个很简单的服务器，但是不知道怎么做了，求指点，真的很简单</a>
					<div>
						问题描述 想做个很简单的服务器,但是不知道怎么做了,求指点,真的很简单 就是c/s模型的服务器端,客户端在安卓手机上,通过URL请求服务器数据,服务器返回一串json数组就好.这个功能的服务器该看什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRvO3b.html" rel="bookmark" class="title">带有通配符的字符串匹配算法</a>
					<div>
						问题描述 带有通配符的字符串匹配算法 C/C++实现 之前面试.遇见一个字符串匹配问题. 大概是这样的: 正常的匹配就不说了, 第一,'*'可以代表连续多个字符. 第二,'a+'可以代表'aa', ' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RKdrb.html" rel="bookmark" class="title">E-MapReduce解决hive comment中文乱码问题</a>
					<div>
						在最新版本的EMR-1.3.0已经解决了hive comment中文乱码问题.如果已经申请了包年包月的集群,用的是老版本,那么可以过下面介绍的步骤解决这个问题. 1.登录mysql变更hive的met ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXL3jz.html" rel="bookmark" class="title">Delphi中MIDAS程序的实例化模型种类&lpar;MIDAS之三&rpar;</a>
					<div>
						Delphi中MIDAS应用程序COM服务器实例化模型种类  (1)Internal Instance     创建一个In-Process的COM程序,即DLL服务器.  (2)Single Ins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqngQz.html" rel="bookmark" class="title">【百度地图API】小学生找哥哥&mdash;&mdash;小学生没钱打车，所以此为公交查询功能</a>
					<div>
						原文:[百度地图API]小学生找哥哥--小学生没钱打车,所以此为公交查询功能 任务描述: 有位在魏公村附近上小学的小朋友,要去北京邮电大学找哥哥.他身上钱很少,只够坐公交的.所以,百度地图API快帮帮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nRA8z.html" rel="bookmark" class="title">通用JS事件写法实现代码&lowbar;表单特效</a>
					<div>
						&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot; &gt; &lt;head&gt; &lt;title&gt;test&lt;/titl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQG3kp.html" rel="bookmark" class="title">求助：请问哪位高手可以帮忙编写一个完整的小游戏程序</a>
					<div>
						问题描述 本人修二专业计算机不过都没去上过课随便考的试要交毕业答辩一般的程序是能看懂的但是还不会编程请哪位高手帮忙编一个简单点的小游戏作为毕业设计要完整的谢谢谢谢模板也可以谢谢谢谢万分感谢 解决方案  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
